<?php
/**
 *   @copyright Copyright (c) 2017 Quality Unit s.r.o.
 *   @author Martin Pullmann
 *   @package WpPostAffiliateProPlugin
 *   @since version 1.9.0
 *
 *   Licensed under GPL2
 */

class postaffiliatepro_Form_Settings_Debugging extends postaffiliatepro_Form_Base {
    const DEBUGGING_CONFIG_PAGE = 'debugging-config-page';
    const DEBUGGING_ENABLED = 'debugging-enabled';
    const DEBUG_FILE = '/postaffiliatepro/log.txt';
    //const DEBUGGING_STYLE = 'debugging-style';

    public function __construct() {
        parent::__construct(self::DEBUGGING_CONFIG_PAGE, 'options.php');
    }

    public function initSettings() {
        register_setting(self::DEBUGGING_CONFIG_PAGE, self::DEBUGGING_ENABLED);
        register_setting(self::DEBUGGING_CONFIG_PAGE, self::DEBUG_FILE);
    }

    protected function getTemplateFile() {
        return WP_PLUGIN_DIR . '/postaffiliatepro/Template/Debugging.xtpl';
    }

    protected function initForm() {
        $this->addHtml('debug_info', '');
        $debugFile = WP_PLUGIN_DIR . self::DEBUG_FILE;

        // check if log file exists
        if (file_exists($debugFile)) {
            $content = file_get_contents($debugFile);
            $html = '<h3>Debug file</h3><textarea readonly rows="20" style="width: 100%;font-family: monospace;">'.$content.'</textarea>';
            $this->addHtml('debug_info', $html);
        }

        $this->addCheckbox(self::DEBUGGING_ENABLED);
        /*$this->addSelect(self::WOOCOMM_DATA1, array(
                '0' => 'general file',
                '1' => 'a file per day'

        ));*/

        $this->addSubmit();
    }

    public function addPrimaryConfigMenu() {
        add_submenu_page('pap-top-level-options-handle', __('Debugging','pap-menu'), __('Debugging','pap-menu'), 'manage_options', 'pap-debugging-page', array($this, 'printDebuggingPage'));
    }

    public function printDebuggingPage() {
        $this->render();
        return;
    }
}

$submenuPriority = 95;
$integration = new postaffiliatepro_Form_Settings_Debugging();
add_action('admin_init', array(
        $integration,
        'initSettings'
), 99);
add_action('admin_menu', array(
        $integration,
        'addPrimaryConfigMenu'
), $submenuPriority);